"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorPanel = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = require("react");
const zustand_1 = require("zustand");
const store_1 = require("../store.cjs");
const utils_1 = require("../utils.cjs");
/**
 * Tabpanel containing a single editor.
 */
function EditorPanel({ className, filename, group = "default", ...props }) {
    const store = (0, store_1.useBoothStore)();
    const active = (0, zustand_1.useStore)(store, (state) => state.groups[group]?.activeFile === filename);
    return ((0, jsx_runtime_1.jsx)("div", { "aria-expanded": active, "aria-labelledby": utils_1.ids.fileTab({ filename, group }), className: (0, classnames_1.default)("lqv-editor-panel", className), hidden: !active, id: utils_1.ids.editorPanel({ filename, group }), role: "tabpanel", children: react_1.Children.map(props.children, (node) => {
            if (typeof node === "object" && "props" in node) {
                return (0, react_1.cloneElement)(node, { filename, group });
            }
            return node;
        }) }));
}
exports.EditorPanel = EditorPanel;
