"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeBooth = exports.useBoothStore = exports.Resize = exports.ReplayMultiple = exports.Replay = exports.Record = exports.FileTabs = exports.EditorPanel = exports.EditorGroup = exports.Editor = exports.Console = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const view_1 = require("@codemirror/view");
const react_1 = require("@lqv/playback/react");
const classnames_1 = __importDefault(require("classnames"));
const react_2 = require("react");
const zustand_1 = require("zustand");
const extensions_1 = require("./extensions.cjs");
const store_1 = require("./store.cjs");
// buttons
__exportStar(require("./components/buttons.cjs"), exports);
var Console_1 = require("./components/Console.cjs");
Object.defineProperty(exports, "Console", { enumerable: true, get: function () { return Console_1.Console; } });
var Editor_1 = require("./components/Editor.cjs");
Object.defineProperty(exports, "Editor", { enumerable: true, get: function () { return Editor_1.Editor; } });
var EditorGroup_1 = require("./components/EditorGroup.cjs");
Object.defineProperty(exports, "EditorGroup", { enumerable: true, get: function () { return EditorGroup_1.EditorGroup; } });
var EditorPanel_1 = require("./components/EditorPanel.cjs");
Object.defineProperty(exports, "EditorPanel", { enumerable: true, get: function () { return EditorPanel_1.EditorPanel; } });
var FileTabs_1 = require("./components/FileTabs.cjs");
Object.defineProperty(exports, "FileTabs", { enumerable: true, get: function () { return FileTabs_1.FileTabs; } });
var Record_1 = require("./components/Record.cjs");
Object.defineProperty(exports, "Record", { enumerable: true, get: function () { return Record_1.Record; } });
var Replay_1 = require("./components/Replay.cjs");
Object.defineProperty(exports, "Replay", { enumerable: true, get: function () { return Replay_1.Replay; } });
Object.defineProperty(exports, "ReplayMultiple", { enumerable: true, get: function () { return Replay_1.ReplayMultiple; } });
var Resize_1 = require("./components/Resize.cjs");
Object.defineProperty(exports, "Resize", { enumerable: true, get: function () { return Resize_1.Resize; } });
__exportStar(require("./extensions.cjs"), exports);
var store_2 = require("./store.cjs");
Object.defineProperty(exports, "useBoothStore", { enumerable: true, get: function () { return store_2.useBoothStore; } });
/**
 * Container for code editing/recording/replaying.
 */
const CodeBooth = ({ children, className, recorder, ...attrs }) => {
    const store = (0, react_2.useRef)();
    if (!store.current) {
        store.current = (0, store_1.makeStore)({ recorder });
    }
    const stateClassNames = (0, zustand_1.useStore)(store.current, (state) => state.classNames);
    /* render */
    return ((0, jsx_runtime_1.jsx)("div", { className: (0, classnames_1.default)(stateClassNames, className), "data-affords": "click", ...attrs, children: (0, jsx_runtime_1.jsx)(store_1.BoothStore.Provider, { value: store.current, children: (0, jsx_runtime_1.jsxs)(react_1.PlaybackContext.Provider, { value: (0, react_1.useME)(), children: [(0, jsx_runtime_1.jsx)(KeyboardShortcuts, {}), children] }) }) }));
};
exports.CodeBooth = CodeBooth;
function KeyboardShortcuts() {
    const store = (0, store_1.useBoothStore)();
    (0, react_2.useEffect)(() => {
        // this is somewhat wasteful but oh well
        function reconfigure() {
            const state = store.getState();
            for (const groupName in state.groups) {
                for (const { view } of state.groups[groupName].files) {
                    view.dispatch({
                        effects: extensions_1.shortcuts.reconfigure([view_1.keymap.of(Object.values(state.shortcuts))]),
                    });
                }
            }
        }
        const unsubs = [];
        // update with new shortcuts
        unsubs.push(store.subscribe((state) => state.shortcuts, reconfigure));
        // update with new editors
        unsubs.push(store.subscribe((state) => state.groups, reconfigure));
        return () => {
            for (const unsub of unsubs) {
                unsub();
            }
        };
    }, []);
    return null;
}
