"use strict";
// eslint-disable-next-line @typescript-eslint/triple-slash-reference
/// <reference path="skulpt.d.ts" />
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PythonInterpreter = void 0;
const skulpt_1 = __importDefault(require("skulpt"));
class PythonInterpreter {
    constructor() {
        this.read = this.read.bind(this);
    }
    read(filename) {
        if (skulpt_1.default.builtinFiles === undefined || skulpt_1.default.builtinFiles["files"][filename] === undefined)
            throw "File not found: '" + filename + "'";
        return skulpt_1.default.builtinFiles["files"][filename];
    }
    run(code) {
        const output = [];
        skulpt_1.default.configure({
            output: (txt) => {
                if (txt !== "\n") {
                    output.push(txt);
                }
            },
            read: this.read,
        });
        return skulpt_1.default.misceval
            .asyncToPromise(() => skulpt_1.default.importMainWithBody("<stdin>", false, code, true))
            .then(() => output);
    }
    runSync(code) {
        const output = [];
        skulpt_1.default.configure({
            output: (txt) => {
                if (txt !== "\n") {
                    output.push(txt);
                }
            },
            read: this.read,
        });
        skulpt_1.default.importMainWithBody("<stdin>", false, code, false);
        return output;
    }
}
exports.PythonInterpreter = PythonInterpreter;
