"use strict";
"use client";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBoothStore = exports.BoothStore = exports.makeStore = void 0;
const react_1 = require("react");
const zustand_1 = require("zustand");
const middleware_1 = require("zustand/middleware");
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
const makeStore = (state = {}) => (0, zustand_1.createStore)()((0, middleware_1.subscribeWithSelector)((set, get) => ({
    // default values
    activeGroup: undefined,
    classNames: ["lqv-codebooth"],
    getActiveFile() {
        const state = get();
        const group = state.groups[state.activeGroup];
        return group?.files?.find((_) => _.filename === group.activeFile);
    },
    getActiveView() {
        return get().getActiveFile().view;
    },
    groups: {},
    messages: [],
    recorder: undefined,
    run: 0,
    shortcuts: {},
    ...state,
})));
exports.makeStore = makeStore;
exports.BoothStore = (0, react_1.createContext)(null);
/** Get a reference to the Zustand store for this CodeBooth. See {@link State} for store shape. */
function useBoothStore() {
    return (0, react_1.useContext)(exports.BoothStore);
}
exports.useBoothStore = useBoothStore;
