import { jsx as _jsx } from "react/jsx-runtime";
import classNames from "classnames";
import { Children, cloneElement } from "react";
import { useStore } from "zustand";
import { useBoothStore } from "../store.mjs";
import { ids } from "../utils.mjs";
/**
 * Tabpanel containing a single editor.
 */
export function EditorPanel({ className, filename, group = "default", ...props }) {
    const store = useBoothStore();
    const active = useStore(store, (state) => state.groups[group]?.activeFile === filename);
    return (_jsx("div", { "aria-expanded": active, "aria-labelledby": ids.fileTab({ filename, group }), className: classNames("lqv-editor-panel", className), hidden: !active, id: ids.editorPanel({ filename, group }), role: "tabpanel", children: Children.map(props.children, (node) => {
            if (typeof node === "object" && "props" in node) {
                return cloneElement(node, { filename, group });
            }
            return node;
        }) }));
}
