"use client";
import { createContext, useContext } from "react";
import { createStore } from "zustand";
import { subscribeWithSelector } from "zustand/middleware";
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
export const makeStore = (state = {}) => createStore()(subscribeWithSelector((set, get) => ({
    // default values
    activeGroup: undefined,
    classNames: ["lqv-codebooth"],
    getActiveFile() {
        const state = get();
        const group = state.groups[state.activeGroup];
        return group?.files?.find((_) => _.filename === group.activeFile);
    },
    getActiveView() {
        return get().getActiveFile().view;
    },
    groups: {},
    messages: [],
    recorder: undefined,
    run: 0,
    shortcuts: {},
    ...state,
})));
export const BoothStore = createContext(null);
/** Get a reference to the Zustand store for this CodeBooth. See {@link State} for store shape. */
export function useBoothStore() {
    return useContext(BoothStore);
}
