/// <reference types="react" />
import { type Extension } from "@codemirror/state";
/** CodeMirror editor. */
export declare function Editor(props: {
    /** Initial content for editor. */
    content?: string;
    /**
     * Whether the editor is editable or not.
     * @default true
     */
    editable?: boolean;
    /** CodeMirror {@link Extension}s to use in the editor. */
    extensions?: Extension[];
    /** Filename for the file being edited. */
    filename?: string;
    /**
     * Group name for editor. You usually specify this on the parent {@link EditorGroup} instead.
     * @default "default"
     */
    group?: string;
}): JSX.Element;
