/// <reference types="react" />
/** Div to hold buttons. */
export declare function Buttons({ className, children }: {
    className?: string;
    children?: React.ReactNode;
}): JSX.Element;
/** Button for clearing the output/console. */
export declare function Clear({ className, children, ...attrs }: React.ButtonHTMLAttributes<HTMLButtonElement>): JSX.Element;
/** Button for copying the contents of one group to another. */
export declare function Copy({ children, className, from: fromGroup, to: toGroup, ...attrs }: React.ButtonHTMLAttributes<HTMLButtonElement> & {
    /** Source editor group. */
    from: string;
    /** Target editor group. */
    to: string;
}): JSX.Element;
/** Button for resetting editor contents to initial state. */
export declare function Reset({ className, children, ...attrs }: React.ButtonHTMLAttributes<HTMLButtonElement>): JSX.Element;
/** Button for running the code. */
export declare function Run({ className, children, ...attrs }: React.ButtonHTMLAttributes<HTMLButtonElement>): JSX.Element;
/** Group selection tab. */
export declare const Tab: React.FC<React.ButtonHTMLAttributes<HTMLButtonElement> & {
    /** ID of {@link EditorGroup} this corresponds to */
    id: string;
}>;
/** Holds a list of {@link Tab}s. */
export declare const TabList: React.FC<React.HTMLAttributes<HTMLDivElement>>;
