/// <reference types="react" />
import type { Extension } from "@codemirror/state";
import { Replay } from "../components/Replay";
/** Python demo */
export declare const PythonDemo: React.FC<{
    /** File contents. */
    content?: string;
    /**
     * CodeMirror extensions to add.
     * @default []
     */
    extensions?: Extension[];
}>;
/** Record Python coding. */
export declare const PythonRecord: React.FC<{
    /** File contents. */
    content?: string;
    /**
     * CodeMirror extensions to add.
     * @default []
     */
    extensions?: Extension[];
}>;
/** Interactive Python replay. */
export declare const PythonReplay: React.FC<{
    children?: React.ReactNode;
    /** File contents. */
    content?: string;
    /**
     * CodeMirror extensions to add.
     * @default []
     */
    extensions?: Extension[];
    /** Coding data to replay. */
    replay: React.ComponentProps<typeof Replay>["replay"];
    /**
     * When replay should start.
     * @default 0
     */
    start?: number;
}>;
/** Run Python code. */
export declare const PythonRun: React.FC;
